var BookmarkManager = 
{
	BOOKMARK_KEY: "bookmark",
	list: new Array(),
	pageBookmarkList: new Array(),
	maxBookmark: 50,
	errorMsg: "",
	inited: false,
	Init: function()
	{
		if (this.inited)
		{
			return ;
		}
	
		this.inited = true;
	
		var lvBookmark = Load(this.BOOKMARK_KEY);
		
//		lvBookmark = "HAH|TKL|1|A|3|1|EU;KOT|KTL|2|D|6|3|EU;HUH|ERL|1,4|B|11|1|EU";
		
		if (lvBookmark != "")
		{
			lvBookmark = lvBookmark.split(";");
			
			for (var i=0; i<lvBookmark.length; i++)
			{
				var lvValue = lvBookmark[i].split("|");
				
				this.AddBookmark(new Bookmark(lvValue[0], lvValue[1], lvValue[2], lvValue[3], lvValue[4], lvValue[5], lvValue[6].split(","), lvValue[7]), false, true);
				
				lvBookmark[i] = "";
				lvValue.length = 0;
			}
			
			lvBookmark.length = 0;
		}
	},
	
	AddBookmark: function(bookmark, isSave, skipChecking)
	{
		skipChecking = skipChecking || null;
		
		if (skipChecking == null)
		{
			skipChecking = false;
		}
		
		if (skipChecking || this.CanAddBookmark(bookmark))
		{
//			this.list.push(bookmark);

			this.list.splice(this.GetAddIndex(bookmark), 0, bookmark);
			
			isSave = isSave || null;
			
			if (isSave == null || isSave == true)
			{
				this.Save();
			}
		}
	},
	AddPageBookmark: function(bookmark)
	{
		this.pageBookmarkList.push(bookmark);
	},
	ClearPageBookmark: function()
	{
		this.pageBookmarkList.length = 0;
	},
	GetPageBookmarkLength: function()
	{
		return this.pageBookmarkList.length;
	},
	GetPageBookmark: function(index)
	{
		if (index > this.GetPageBookmarkLength())
		{
			return null;
		}
		else
		{
			return this.pageBookmarkList[index];
		}
	},
	Save: function()
	{
		var lvString = "";
		
		for (var i=0; i<this.list.length;i++)
		{
			var lvBookmark = this.list[i];
			
			if (i > 0)
			{
				lvString += ";";
			}
			
			lvString += lvBookmark.station + "|" + lvBookmark.line + "|";
			
			for (var j=0; j<lvBookmark.platformNo.length; j++)
			{
				if (j > 0)
				{
					lvString += ",";
				}
				
				lvString += lvBookmark.platformNo[j];
			}
			
			lvString += "|";
			
			for (var j=0; j<lvBookmark.exit.length; j++)
			{
				if (j > 0)
				{
					lvString += ",";
				}
				
				lvString += lvBookmark.exit[j];
			}
			
			lvString += "|" + lvBookmark.car + "|" + lvBookmark.door + "|";
			
//			if (lvBookmark.type != null)
//			{
//				var lvTypes = GetObjectAsArray(lvBookmark.type);
				
				for (var j=0; j<lvBookmark.type.length; j++)
				{
					if (j > 0)
					{
						lvString += ",";
					}
			
					lvString += lvBookmark.type[j];
				}
//			}
			
			lvString += "|" + lvBookmark.platformLabel;
		}
		
		Save(this.BOOKMARK_KEY, lvString);
		
		lvString = "";
	},
	
	CanAddBookmark: function(bookmark)
	{
		if (bookmark == null)
		{
			return false;
		}
	
		var lvReturnBool = (this.list.length < this.maxBookmark);
		
		if (!lvReturnBool)
		{
			this.errorMsg = GetMsgText("BOOKMARK_MAX");
		}
		else
		{
/*			if (GetObjectAsArray(bookmark.car).length == 1)
			{
				for (var i=0; i<this.list.length; i++)
				{
					if (this.IsSameBookmark(bookmark, this.list[i]))
					{
						lvReturnBool = false;
						break;
					}
				}
*/
				lvReturnBool = !(this.IsBookmarkExist(bookmark));

				if (!lvReturnBool)
				{
					this.errorMsg = GetMsgText("BOOKMARK_SAME");
				}
//			}
		}

		return lvReturnBool;
	},
	IsBookmarkExist: function(bookmark)
	{
		if (bookmark != null && GetObjectAsArray(bookmark.car).length == 1)
		{
			for (var i=0; i<this.list.length; i++)
			{
				if (this.IsSameBookmark(bookmark, this.list[i]))
				{
					return true;
				}
			}
		}

		return false;
	},
	GetErrorMsg: function()
	{
		return this.errorMsg;
	},
	GetList: function()
	{
		var lvReturnList = new Array();
		
		for (var i=0; i<this.list.length; i++)
		{
			lvReturnList.push(this.list[i]);
		}
	
		return lvReturnList;
	},
/*	SortBookmark: function()
	{
	
	},
	IsValidBookmark: function()
	{
		return true;
	},
*/	IsSameBookmark: function(bookmark1, bookmark2)
	{
		if (bookmark1.station != bookmark2.station)
		{
			return false;
		}
		
		if (bookmark1.line != bookmark2.line)
		{
			return false;
		}
		
		if (bookmark1.platformNo.length != bookmark2.platformNo.length)
		{
			return false;
		}
		
		for (var i=0; i<bookmark1.platformNo.length; i++)
		{
			if (bookmark1.platformNo[i] != bookmark2.platformNo[i])
			{
				return false;
			}
		}
		
		if (bookmark1.exit.length != bookmark2.exit.length)
		{		
			return false;
		}
		
		if (GetObjectAsArray(bookmark1.exit)[0] != GetObjectAsArray(bookmark2.exit)[0])
		{
			return false;
		}
		
		if (GetObjectAsArray(bookmark1.car)[0] != GetObjectAsArray(bookmark2.car)[0])
		{
			return false;
		}
		
		if (GetObjectAsArray(bookmark1.door)[0] != GetObjectAsArray(bookmark2.door)[0])
		{
			return false;
		}
		
/*		if (GetObjectAsArray(bookmark1.type)[0] != GetObjectAsArray(bookmark2.type)[0])
		{
			return false;
		}
*/		
//		var lvType1 = GetObjectAsArray(bookmark1.type);
//		var lvType2 = GetObjectAsArray(bookmark2.type);
		
		if (bookmark1.length != bookmark2.length)
		{
			return false;
		}
		
		for (var i=0; i<bookmark1.type.length; i++)
		{
			if (bookmark1.type[i] != bookmark2.type[i])
			{
				return false;
			}
		}
		
		return true;
	},
	RemoveBookmark: function(index)
	{
		if (index < this.GetPageBookmarkLength())
		{
			this.list.splice(index, 1);
			
			this.Save();
		}
	},
	GetAddIndex: function(bookmark)
	{
		var lvListHasSameStation = false;
		
		for (var i=0; i<this.list.length; i++)
		{
			if (this.list[i].station == bookmark.station)
			{
				lvListHasSameStation = true;
			}
			else if (lvListHasSameStation)
			{
				return i;
			}
		}
		
		return this.list.length;
	}
};

var Bookmark = function(station, line, platformNo, exit, car, door, type, platformLabel)
{
	this.station = station;
	this.line = line;
	
	if (typeof platformNo == "string")
	{
		this.platformNo = platformNo.split(",");
	}
	else
	{
		this.platformNo = platformNo;
	}
	
	if (exit != null && exit != "")
	{	
		if (typeof exit == "string")
		{
			this.exit = exit.split(",");
		}
		else
		{
			this.exit = exit;
		}
	}
	else
	{
		this.exit = [];
	}
	
	this.car = car;
	this.door = door;
	this.type = GetObjectAsArray(type);
	this.platformLabel = platformLabel;
}

Bookmark.prototype.Clone = function()
{
	var lvBookmark = new Bookmark(this.station, this.line, this.platformNo, this.exit, this.car, this.door, this.type, this.platformLabel)
	
	return lvBookmark;
}