var VIEW_INDEX = 0;
var VIEW_INDEX_BACK = -1;

if (isAndroid)
{
	document.addEventListener('deviceready', function()
	{
		document.addEventListener("backbutton", OnBackKey, false);
	}, false);
}

$(document).ready(function()
{
	$("#mode_basic").click(function()
	{
		GoToPage(1);
	});
	
	$("#mode_interchange").click(function()
	{
		GoToPage(2);
	});
	
	$("#mode_place").click(function()
	{
		GoToPage(4);
	});
	
	$("#about").click(function()
	{
		GoToPage(7);
	});
	
	$("#disclaimer").click(function()
	{
		GoToPage(6);
	});
	
	$("#faq").click(function()
	{
		GoToPage(5);
	});
	
	$('#facebook').click(function()
	{
//		OpenWebPage("https://www.facebook.com/1741695776058705/");
//		OpenWebPage("fb://page/1741695776058705/");
		OpenFbPage();
	});
	
	var _TRANSLATION =
	{
		mode_basic: ["落車指南", "Alighting Planner"],
		disclaimer: ["免責聲明", "Disclaimer"],
		about: ["關於 Fastpass", "About Fastpass"],
		mode_interchange: ["轉車指南", "Interchange Planner"],
		mode_place: ["地點指南", "Place Planner"],
		faq: ["常見問題","FAQ"]
	};
	
	$.each(_TRANSLATION, function(key, data)
	{
		$("#" + key).val(data[LANG]).button("refresh");
	});
	
/*	_TRANSLATION =
	{
		marquee: ["上車前，請留意車卡及車門號碼", "Please notice car and door no. before boarding"]
	};
	
	$.each(_TRANSLATION, function(key, data)
	{
		$("#" + key).html(data[LANG]);
	});
*/
	if (AllowStorage())
	{
		CreateBookmarkContent();
	}
	else
	{
		$('#button_bookmark').hide();
	}
	
	CreateHelpBar();
	
	_TRANSLATION = null;
	
/*	$('#header').toolbar({
		tapToggle: false
	});*/
});

function CreateBookmarkContent()
{
	var _TRANSLATION =
	{
		heading_bookmark: ["書籤", "Bookmark"],
		no_record: ["未有紀錄 - 可在<b>落車指南</b>及<b>轉車指南</b>將落車位置加到書籤", "No record found - Bookmark Alighting Position in <b>Alighting Planner</b> and <b>Interchange Planner</b>"]
	};

	var lvString = "<h4>" + _TRANSLATION["heading_bookmark"][LANG] + "</h4>";

	BookmarkManager.Init();
	BookmarkManager.ClearPageBookmark();
	
	var lvBookmarkList = BookmarkManager.GetList();
	
	if (lvBookmarkList.length > 0)
	{
		var lvPreviousBookmarkStation = "";
		
		for (var i=0; i<lvBookmarkList.length; i++)
		{
			var lvBookmark = lvBookmarkList[i];
			
			if (lvPreviousBookmarkStation == "" || lvPreviousBookmarkStation != lvBookmark.station)
			{
//				lvString += "<div class=\"ui-bar ui-bar-a\">" + GetTranslation(lvBookmark.station) + "</div>";
				lvString += "<div class=\"ui-bar ui-bar-a station-color-block " + lvBookmark.station + "\"><span class=\"chinese-name\">" + TRANSLATION[lvBookmark.station][0] + "</span><br/>" + TRANSLATION[lvBookmark.station][1] + "</div>";
				
				lvPreviousBookmarkStation = lvBookmark.station;
			}
			
			lvString += "<div class=\"ui-body ui-body-a\">";

//			+ "<div onclick=\"PopUpBookmark(this)\" data-bookmark-index=\"" + BookmarkManager.GetPageBookmarkLength() + "\">";
			
			for (var j=0; j<lvBookmark.platformNo.length; j++)
			{
				lvString += "<div class=\"newPlatformNo indexPlatformNo bg_" + lvBookmark.line + "\">" + lvBookmark.platformNo[j] + "</div>";
			}
			
//			lvString += "</div>";
			
			if (lvBookmark.exit != "")
			{
				lvString += "<div class=\"newExitBox\">" + lvBookmark.exit + "</div>";
			}
			
			lvString += "<div class=\"posNoBox\">" + lvBookmark.car + "</div><div class=\"posNoBox_door\">" + lvBookmark.door + "</div>";
			
			for (var j=0; j<lvBookmark.type.length; j++)
			{
//				lvString += "<div class=\"left\">" + lvBookmark.type + "</div>";
				lvString += "<img alt=\"" + lvBookmark.type[j] + "\" style=\"float: left\" src=\"img/" + lvBookmark.type[j] + ".png\" />";
			}
			
//			lvString += "<div class=\"right\"><img src=\"script/images/icons-png/delete-black.png\" onclick=\"DeleteBookmark(this)\" data-bookmark-index=\"" + BookmarkManager.GetPageBookmarkLength() + "\"/></div></div>";
			lvString += "<div class=\"right\"><a style=\"margin: 0\" class=\"ui-btn ui-shadow ui-corner-all ui-icon-delete ui-btn-icon-notext\" onclick=\"DeleteBookmark(this)\" data-bookmark-index=\"" + BookmarkManager.GetPageBookmarkLength() + "\"></a></div></div>";
		
			BookmarkManager.AddPageBookmark(lvBookmark);
		}
	}
	else
	{
		lvString += "<p class=\"ui-mini no_bookmark_record\">" + _TRANSLATION["no_record"][LANG] + "</p>";
	}

	try
	{
		$('#button_bookmark').collapsible("destroy");
	}
	catch(e)
	{
	
	}
	
	$('#button_bookmark').html(lvString).collapsible().trigger("create").collapsible(
	{
		collapsedIcon: "tag",
		expandedIcon: "tag"
	});		
	$('#button_bookmark div.ui-collapsible-content').css("padding", "0");
	
	if (lvBookmarkList.length > 0)
	{
		$('#button_bookmark').collapsible( "expand" );
		lvBookmarkList.length = 0;
	}

	lvString = "";
	_TRANSLATION = null;
}

/*function OpenFacebook()
{
	navigator.app.loadUrl("https://www.facebook.com/Fastpass.hk/", {openExternal : true});
}
*/

function DeleteBookmark(bookmark)
{
	var lvBookmarkIndex = parseInt($(bookmark).attr("data-bookmark-index"));
	var lvBookmark = BookmarkManager.GetPageBookmark(lvBookmarkIndex);

	if (lvBookmark != null)
	{
//		var lvString = GetMsgText("BOOKMARK_REMOVE") + "\n\n" + GetCoreText("LINE") + ": " + GetCoreText(lvBookmark.line) + "\n" + GetCoreText("PLATFORM") + ": ";
		var lvString = "-" + GetCoreText("ARRIVING_LINE") + ": " + GetCoreText(lvBookmark.line) + "\n-" + GetCoreText("ALIGHTING") + "\n-" + GetCoreText("PLATFORM") + ": ";
		
		for (var i=0; i<lvBookmark.platformNo.length; i++)
		{
			lvString += "(" + lvBookmark.platformNo[i] + ")";
		}
		
		lvString += " " + GetCoreText(lvBookmark.platformLabel)
		
		+ "\n-" + GetCoreText("POSITION") + ": " + lvBookmark.car + "-" + lvBookmark.door;
		
		if (lvBookmark.exit.length > 0)
		{
			lvString += "\n-" + GetCoreText("EXIT") +": " + lvBookmark.exit[0];
		}
		
		lvString += "\n-" + GetCoreText("TYPE") +": ";
		
		for (var i=0; i<lvBookmark.type.length; i++)
		{
			if (i > 0)
			{
				lvString += "/ ";
			}
			
			lvString += GetCoreText(lvBookmark.type[i]);
		}
		
/*		var lvConfirm = confirm(lvString);
		
		if (lvConfirm)
		{
			BookmarkManager.RemoveBookmark(lvBookmarkIndex);
			location.reload();
		}
		
*/		
		NativeConfirm(GetMsgText("BOOKMARK_REMOVE"), lvString, [GetMsgText("CONFIRM"), GetMsgText("CANCEL")], function(param)
		{
			var lvRemoveBookMark = false;
		
			if (isAndroid || isIOS)
			{
				lvRemoveBookMark = (param == 1);
			}
			else
			{
				lvRemoveBookMark = (param == true);
			}
			
			if (lvRemoveBookMark)
			{
				BookmarkManager.RemoveBookmark(lvBookmarkIndex);
				CreateBookmarkContent();
//				location.reload();
			}
		});
		
		lvString = "";
	}
}
/*
function PopUpBookmark(bookmark)
{
	var lvBookmarkIndex = parseInt($(bookmark).attr("data-bookmark-index"));
	var lvBookmark = BookmarkManager.GetPageBookmark(lvBookmarkIndex);
	
	if (lvBookmark != null)
	{
		var lvString = "<p>" + GetCoreText(lvBookmark.line) + "</p>";
		
		if (lvBookmark.platformLabel != null)
		{
			lvString += "<p>" + GetCoreText(lvBookmark.platformLabel) + "</p>";
		}
	
		$('#popup').html(lvString).popup("open");
		
		lvBookmark = null;
		lvString = "";
	}
}*/

function OnBackKey()
{
	NativeConfirm(GetMsgText("REMINDER"), GetMsgText("EXIT_APP"), [GetMsgText("CONFIRM"), GetMsgText("CANCEL")], function(param)
	{
		if (param == 1)
		{
			navigator.app.exitApp();
		}
	});
}

function GoToPage(viewIndex)
{
	if (isAndroid)
	{
		document.removeEventListener("backbutton", OnBackKey, false);
	}
	
//	Location(link + "?lang=" + LANG);

	GoToView(viewIndex, {lang: LANG});
}

function CreateHelpBar()
{
	var _TRANSLATION =
	{
		HELP: ["說明", "Help"],
		HELP_CONTENT: ["歡迎使用 Fastpass - 請選擇項目<ul style=\"padding-left:10px;margin-top:0;margin-bottom:0\"><li>落車指南 - 推薦落車位置，更快到出口</li><li>轉車指南 - 推薦落車位置，轉車更快捷</li><li>地點指南 - 推薦前往指定地點的落車站及出口</li><li>書籤 - 可將落車位置加到書籤</li></ul>"
		, "Welcome to Fastpass - Please select option<ul style=\"padding-left:10px;margin-top:0;margin-bottom:0\"><li>Alighting Planner - Suggest Alighting Position to reach Exit quicker</li><li>Interchange Planner - Suggest Alighting Position for quicker interchanging</li><li>Place Planner - Suggest Alighting Station and Exit for designated places</li><li>Bookmark - Bookmark Alighting Position</li></ul>"]
	};
	
	var lvString = "<div id=\"help\" data-role=\"collapsible\" data-mini=\"true\"><h3>" + _TRANSLATION.HELP[LANG] + "</h3>" + _TRANSLATION.HELP_CONTENT[LANG] + "</div>";
	
	_TRANSLATION = null;
	
	$("#main").prepend(lvString);
	lvString = null;
	
	SetUpHelpBar($('#help'));
	
/*	$('#help').collapsible(
	{
		collapsedIcon: "info",
		expandedIcon: "info",
		collapsed: (Load("ExpandHelpBar") != "T"),
		expand: function(event, ui)
		{
			Save("ExpandHelpBar", "T");
		},
		collapse: function(event, ui)
		{
			Save("ExpandHelpBar", "F");
		}
	});
	
	$('#help').find('div.ui-collapsible-content').addClass('ui-mini');*/
}