	var VIEW_INDEX = 2;
	var VIEW_INDEX_BACK = 0;

	var PRE_DEFINED =
	{
		INTERCHANGES:
		{		
			"TWL":["LAK","MEF","PRE","MOK","YMT","TST","ADM","CEN"],
			"KTL":["TIK","YAT","KOT","PRE","MOK","YMT"],
			"ISL":["CEN","ADM","NOP","QUB"],
			"TKL":["TKO","TIK","YAT","QUB","NOP"],
			"SIL":["ADM"],
			"TCL":["SUN","LAK","NAC","HOK"],
			"DRL":["SUN"],
			"ERL":["TAW","KOT","HUH"],
			"WRL":["MEF","NAC","ETS","HUH"],
			"MOL":["TAW"]
		}
	};

	$(document).ready(function()
	{
		InitBackButton();

		var _TRANSLATION =
		{
			headerText: ["轉車指南", "Interchange Planner"],
			selectText: ["請選擇轉車站", "Please select interchange station"]
		};

		$.each(_TRANSLATION, function(key, data)
		{
			$("#" + key).text(data[LANG]);
		});

	//	GetXML("data/core2", ProcessCoreXML);
		Init_Interchanges_Data();

		CreateHelpBar();

		_TRANSLATION = null;
	});

function ProcessCoreXML(data)
{
	if (data == null)
	{
		return ;
	}
	
	data = $.xml2json(data).line;
	
	if (data == null)
	{
		return ;
	}
	
	var lvString = "<div data-role=\"collapsible-set\">"; 
	
	$.each(data, function(key, data)
	{		
		lvString += "<div data-role=\"collapsible\" data-inset=\"false\"><h3 class=\"border_bottom_" + key + "\">" + GetCoreText(key) + "</h3>";
	
		var lvInterchange = GetObjectAsArray(data.interchange);
		
		if (lvInterchange.length > 0)
		{
			lvString += "<ul data-role=\"listview\">";
			
			for (var i=0; i<lvInterchange.length; i++)
			{
				lvString += "<li><a onclick=\"PressInterchange('" + lvInterchange[i] + "')\">" + GetTranslation(lvInterchange[i]) + "</a></li>";
			}
			
			lvString += "</ul>";
		}
		
		lvInterchange.length = 0;
	
		lvString += "</div>";
	});
	
	lvString += "</div>";
	
	$('#main').append(lvString).trigger("create");
	
	lvString = null;
	data = null;
}

function Init_Interchanges_Data()
{
	var lvString = "<div data-role=\"collapsible-set\">"; 

	$.each(PRE_DEFINED.INTERCHANGES, function(key, data)
	{
		lvString += "<div data-role=\"collapsible\" data-inset=\"false\"><h3 class=\"border_bottom_" + key + "\">" + GetCoreText(key) + "</h3><ul data-role=\"listview\">";

		for (var i=0; i<data.length; i++)
		{
			lvString += "<li><a onclick=\"PressInterchange('" + data[i] + "')\">" + GetTranslation(data[i]) + "</a></li>";
		}

		lvString += "</ul></div>";
	});

	lvString += "</div>";

	$('#main').append(lvString).trigger("create");

	lvString = null;
}

function PressInterchange(label)
{
	if (label != null && label != "")
	{
		Location("mode_interchange_station.html?station=" + label);
	}
}

function CreateHelpBar()
{
	var _TRANSLATION =
	{
		HELP: ["說明", "Help"],
		HELP_CONTENT: ["推薦落車位置，轉車更快捷", "Suggest Alighting Position for faster interchanging"]
	};
	
	var lvString = "<div id=\"help\" data-role=\"collapsible\" data-mini=\"true\"><h3>" + _TRANSLATION.HELP[LANG] + "</h3>" + _TRANSLATION.HELP_CONTENT[LANG] + "</div>";
	
	_TRANSLATION = null;
	
	$("#main").prepend(lvString);
	lvString = null;
	
	SetUpHelpBar($('#help'));
	
/*	$('#help').collapsible(
	{
		collapsedIcon: "info",
		expandedIcon: "info",
		collapsed: (Load("ExpandHelpBar") != "T"),
		expand: function(event, ui)
		{
			Save("ExpandHelpBar", "T");
		},
		collapse: function(event, ui)
		{
			Save("ExpandHelpBar", "F");
		}
	});
	
	$('#help').find('div.ui-collapsible-content').addClass('ui-mini');*/
}