var VIEW_INDEX = 3;
var VIEW_INDEX_BACK = 2;

var STATION = GetRequestParam("station");
var onConfirmAddBookmarkIndex = -1;
var onConfirmAddBookmarkButton = null;

var _TRANSLATION;

var InterchangeStationManager =
{
	station: new Array(),
	platform: new Array(),
	Destroy: function()
	{
		this.station.length = 0;
		this.platform.length = 0;
	},
	GetPlatform: function(index)
	{
		if (index >= this.platform.length)
		{
			return null;
		}
		else
		{
			return this.platform[index];
		}
	},
	AddPlatform: function(platform)
	{
		this.platform.push(platform);
	},
	AddStation: function(station)
	{
		this.station.push(station);
	},
	GetPlatformLength: function()
	{
		return this.platform.length;
	}
};

var Platform = function(line, platformNo, label)
{
	this.line = line;
	this.platformNo = platformNo;
	this.label = label;
}

var Station = function(label, platform)
{
	this.label = label;
	this.platform = platform;
}

$(document).ready(function()
{
//	$.mobile.loading('show');
	overlayShow();

	InitBackButton();
	
	_TRANSLATION =
	{
		headerText: ["轉車指南", "Interchange Planner"]	
	};
		
	$.each(_TRANSLATION, function(key, data)
	{
		$("#" + key).text(data[LANG]);
	});
		
	_TRANSLATION =
	{
		WALK_TO_OPPOSITE_PLATFORM: ["到對面月台上車", "Board the train at the opposite platform"],
		WALK_TO_HOK: ["到香港站轉車", "Change to train at Hong Kong station"],
		WALK_TO_CEN: ["到中環站轉車", "Change to train at Central station"],
		WALK_TO_ETS: ["到尖東站轉車", "Change to train at East Tsim Sha Tsui station"],
		WALK_TO_TST: ["到尖沙咀站轉車", "Change to train at Tsim Sha Tsui station"],
		ALIGHT_POS: ['從(卡-門)落車', 'Alight at<br/>(Car No - Door No)'],
		BOARDING_POS: ["預計從(卡-門)上車", "To board at<br/>(Car No - Door No)"],
		ALIGHTING_PLATFORM: ["落車月台", "Alighting Platform"],
		BOARDING_PLATFORM: ["上車月台", "Boarding Platform"],
		INTERCHANGE: ["轉車", "Interchange "],
		ESCALATOR: ["乘扶手電梯及步行到上車月台", "Take escalator and walk to the boarding platform"],
		STATION: ["站", " Station"]
	};
	
//	$('#stationText').text(GetTranslation(STATION) + _TRANSLATION.STATION[LANG]);
	
	if (STATION != "")
	{
		GetXML("data/station/" + STATION, ProcessCoreXML);
	}
	
	CreateHelpBar();
});

function ProcessCoreXML(data)
{
	if (data == null)
	{
		return ;
	}
	
	data = $.xml2json(data).interchange;
	
	if (data == null)
	{
		return ;
	}
	
	if (AllowStorage())
	{
		BookmarkManager.Init();
		BookmarkManager.ClearPageBookmark();
	}
	
//	var lvStation = new Array();
	
	// Init InterchangeStationManager
	
	var lvPlatformIndex = null;
	
	if (data.station == null)
	{
		var lvDataPlatform = GetObjectAsArray(data.platform);
		
		lvPlatformIndex = new Array();
		
		for (var i=0; i<lvDataPlatform.length; i++)
		{
			var lvPlatform = lvDataPlatform[i];

			lvPlatformIndex.push(InterchangeStationManager.GetPlatformLength());
			
			InterchangeStationManager.AddPlatform(new Platform(lvPlatform.line, GetObjectAsArray(lvPlatform.number), lvPlatform.label));
		}
		
		InterchangeStationManager.AddStation(new Station(STATION, lvPlatformIndex));
	}
	else
	{
		var lvStations = GetObjectAsArray(data.station);
		
		for (var i=0; i<lvStations.length; i++)
		{
			lvPlatformIndex = new Array();
			
			var lvPlatforms = GetObjectAsArray(lvStations[i].platform);
			
			for (var j=0; j<lvPlatforms.length; j++)
			{
				var lvPlatform = lvPlatforms[j];

				lvPlatformIndex.push(InterchangeStationManager.GetPlatformLength());
				
				InterchangeStationManager.AddPlatform(new Platform(lvPlatform.line, GetObjectAsArray(lvPlatform.number), lvPlatform.label));
			}
		
			InterchangeStationManager.AddStation(new Station(lvStations[i].label, lvPlatformIndex));
		}
	}


	// Gen station/platform info

	var lvString = "";

	for (var i=0; i<InterchangeStationManager.station.length; i++)
	{
		var lvStation = InterchangeStationManager.station[i];
		
		lvString += "<div class=\"ui-bar ui-bar-a\">" + GetTranslation(lvStation.label) + _TRANSLATION.STATION[LANG] + " " + GetCoreText("PLATFORM") + "</div>";
	
		if (lvStation.platform != null)
		{
			lvString += "<div class=\"ui-body ui-body-a\" style=\"padding: 0\"><table>";

			for (var j=0; j<lvStation.platform.length; j++)
			{
				lvString += "<tr><td>";
				
				var lvPlatform = InterchangeStationManager.GetPlatform(lvStation.platform[j]);
				var lvPlatformNo = GetObjectAsArray(lvPlatform.platformNo);
					
				for (var k=0; k<lvPlatformNo.length; k++)
				{
					lvString += "<div class=\"newPlatformNo bg_" + lvPlatform.line + "\">" + lvPlatformNo[k] + "</div>";
				}
				
//				lvPlatformNo.length = 0;
				
				lvString += "</td><td>";
				
				if (lvPlatform.label != null)
				{
					if (lvPlatform.label.override == null)
					{
						lvString += GetCoreText(lvPlatform.line) + " " + GetCoreText(lvPlatform.label);
					}
					else
					{
						lvString += GetXMLStr(lvPlatform.label.override);
					}
				}
				
				lvString += "</td></tr>";
			}
			
			lvString += "</table></div>";
		}
	}
	
	lvString += "<div data-role=\"collapsible-set\">"; 
	
	var lvSets = GetObjectAsArray(data.set);
	
	for (var i=0; i<lvSets.length; i++)
	{		
		var lvSet = lvSets[i];

		lvString += "<div data-role=\"collapsible\" data-inset=\"false\"><h3>";

		if (lvSet.label.override == null)
		{
			if (lvSet.label.fromTrainTo != null)
			{
				lvString += GetCoreText("INTERCHANGE_TO_2", ["@station1", GetTranslation(lvSet.label.to), "@station2", GetTranslation(lvSet.label.fromTrainTo)]);
			}
			else
			{
				lvString += GetCoreText("INTERCHANGE_TO", ["@station", GetTranslation(lvSet.label.to)]);
			}
		}
		else
		{
			lvString += GetXMLStr(lvSet.label.override);
		}
		
		lvString += "</h3>";
		
		var lvPositions = GetObjectAsArray(lvSet.position);
		
		// Gen Position Table
		
		if (lvPositions.length > 0)
		{
			lvString += "<div class=\"ui-body ui-body-a\" style=\"padding: 0\"><table class=\"posInfoTable\">";
			
			if (lvSet.info != null)
			{
				lvString += "<tr><td colspan=\"2\"><table><tr><td><a style=\"display:inline-block; vertical-align: middle\" class=\"ui-nodisc-icon ui-btn ui-shadow ui-corner-all ui-icon-alert ui-btn-icon-notext ui-alt-icon\"></a></td><td>";
				
				if (lvSet.info.override == null)
				{
					if (_TRANSLATION[lvSet.info] != null)
					{
						lvString += _TRANSLATION[lvSet.info][LANG];
					}
				}
				else
				{
					lvString += GetXMLStr(lvSet.info.override);
				}
				
				lvString += "</td></tr></table></td></tr>";
			}
			
			lvString += "<tr><td>" + _TRANSLATION.ALIGHTING_PLATFORM[LANG] + "</td><td>" + _TRANSLATION.BOARDING_PLATFORM[LANG] + "</td></tr><tr><td>";
			
			var lvFromPlatform = InterchangeStationManager.GetPlatform(lvSet.from);
			var lvToPlatform = InterchangeStationManager.GetPlatform(lvSet.to);

			// Gen From Platform No
			
			for (var j=0; j<lvFromPlatform.platformNo.length; j++)
			{
				lvString += "<div class=\"newPlatformNo bg_" + lvFromPlatform.line + "\">" + lvFromPlatform.platformNo[j] + "</div>";
			}
			
			lvString += "</td><td>";
			
			// Gen To Platform No

			for (var j=0; j<lvToPlatform.platformNo.length; j++)
			{
				lvString += "<div class=\"newPlatformNo bg_" + lvToPlatform.line + "\">" + lvToPlatform.platformNo[j] + "</div>";
			}
			
			lvString += "</td></tr><tr><td>" + _TRANSLATION.ALIGHT_POS[LANG] + "</td><td>" + _TRANSLATION.BOARDING_POS[LANG] + "</td></tr>";
			
			// Gen Position Pairs
			
			for (var j=0; j<lvPositions.length; j++)
			{
				var lvPosition = lvPositions[j];
				
				lvString += "<tr><td>";
				
				// Gen Page Bookmark
				
				if (AllowStorage())
				{
					var lvPositionType = new Array();
					
					if (lvPosition.type != null)
					{
						lvPositionType.push(lvPosition.type);
					}
					
					if (lvSet.toLabel == null)
					{
						lvPositionType.push(lvToPlatform.line + lvToPlatform.label);
					}
					else
					{
						lvPositionType.push(lvToPlatform.line + lvSet.toLabel);
					}
					
					var lvBookmark = new Bookmark(STATION, lvFromPlatform.line, lvFromPlatform.platformNo, null, lvPosition.from.car, lvPosition.from.door, lvPositionType, lvFromPlatform.label);
					
					lvString += "<a style=\"display:inline-block; vertical-align: middle\" class=\"ui-btn ui-shadow ui-corner-all ui-icon-tag ui-btn-icon-notext";
					
					if (BookmarkManager.IsBookmarkExist(lvBookmark))
					{
						lvString += " bookmarked";
					}
					
					lvString += "\" onclick=\"PressBookmark(this)\" data-bookmark-index=\"" + BookmarkManager.GetPageBookmarkLength() + "\"></a>";

					BookmarkManager.AddPageBookmark(lvBookmark);
				}
				
				lvString += "<div class=\"posNoBox mode_interchange_pos_box\">" + lvPosition.from.car + "</div><div class=\"posNoBox_door mode_interchange_pos_box\">" + lvPosition.from.door + "</div>";
				
				if (lvPosition.type != null)
				{
					lvString += "<img class=\"mode_interchange_type\" alt=\"" + lvPosition.type + "\" src=\"img/" + lvPosition.type + ".png\" />";
				}
				
				lvString += "</td><td><div class=\"posNoBox\">" + lvPosition.to.car + "</div><div class=\"posNoBox_door\">" + lvPosition.to.door + "</div></td></tr>";
			}
			
			lvString += "</table></div>";
		}

		lvString += "</div>";
	};
	
	lvString += "</div>";
	
	$('#main').append(lvString).trigger("create");

//	$.mobile.loading('hide');
	overlayHide();

//	if (lvSets.length == 1)
//	{
//		$("div.ui-collapsible").collapsible("expand");
//	}
	
	lvSets.length = 0;
	lvString = null;
	data = null;
	
	InterchangeStationManager.Destroy();
}

function PressBookmark(bookmark)
{
	onConfirmAddBookmarkButton = bookmark;
	onConfirmAddBookmarkIndex = parseInt($(bookmark).attr("data-bookmark-index"));
	
	var lvBookmark = BookmarkManager.GetPageBookmark(onConfirmAddBookmarkIndex);
	
	if (!BookmarkManager.CanAddBookmark(lvBookmark))
	{
		NativeAlert(GetMsgText("BOOKMARK"), BookmarkManager.GetErrorMsg(), GetMsgText("DISMISS"));
		return ;
	}

	// Add line and alighting platform
	
	var lvString = "-" + GetCoreText("ARRIVING_LINE") + ": " + GetCoreText(lvBookmark.line) + "\n-" + GetCoreText("ALIGHTING")
	
	+ "\n-" + GetCoreText("PLATFORM") + ": ";
	
	// Add platform no
	
	for (var i=0; i<lvBookmark.platformNo.length; i++)
	{
		lvString += "(" + lvBookmark.platformNo[i] + ")";
	}
	
	// Add platform label
	
	lvString += " " + GetCoreText(lvBookmark.platformLabel);
		
	var lvCar = GetObjectAsArray(lvBookmark.car);

	if (lvCar.length == 0 || lvCar.length > 2)
	{
		lvString = "";
		return ;
	}

	// Add alighting position
	
	lvString += "\n-" + GetCoreText("POSITION") + ": " + lvBookmark.car + "-" + lvBookmark.door;
	
	// Add type
	
	if (lvBookmark.type.length > 0)
	{
		lvString += "\n-" + GetCoreText("TYPE") +": ";
		
		for (var i=0; i<lvBookmark.type.length; i++)
		{
			if (i > 0)
			{
				lvString += "/ ";
			}
			
			lvString += GetCoreText(lvBookmark.type[i]);
		}
	}
		
	NativeConfirm(GetMsgText("BOOKMARK_ADD"), lvString, [GetMsgText("CONFIRM"), GetMsgText("CANCEL")], onConfirmAddBookmark);
			
	lvString = "";
}

function onConfirmAddBookmark(param)
{
	var lvAddBookmark = false;
	var lvBookmark = null;

	if (!isAndroid && !isIOS)
	{
		lvAddBookmark = (param == 1);
		lvBookmark = BookmarkManager.GetPageBookmark(onConfirmAddBookmarkIndex);
		
		if (GetObjectAsArray(lvBookmark.car).length > 1)
		{
			lvAddBookmark = false;
			
			NativeAlert("", "DISABLED adding bookmark with multiple doors/cars", "");
		}
	}	
	else if (param > 0)
	{
		lvBookmark = BookmarkManager.GetPageBookmark(onConfirmAddBookmarkIndex).Clone();		
		var lvBookmarkCar = GetObjectAsArray(lvBookmark.car);
		
		if (lvBookmarkCar.length == 1)
		{
			lvAddBookmark = param == 1;
		}
		else if (param != 3)
		{
			lvBookmark.car = lvBookmark.car[param-1];
			lvBookmark.door = lvBookmark.door[param-1];
			lvBookmark.type = lvBookmark.type[param-1];
			
			lvAddBookmark = BookmarkManager.CanAddBookmark(lvBookmark);
			
			if (!lvAddBookmark)
			{
				NativeAlert(GetMsgText("BOOKMARK"), BookmarkManager.GetErrorMsg(), GetMsgText("DISMISS"));
			}
		}
	}
		
	if (lvAddBookmark)
	{
		BookmarkManager.AddBookmark(lvBookmark);

		NativeAlert(GetMsgText("BOOKMARK"), GetMsgText("BOOKMARK_ADDED"), GetMsgText("DISMISS"));
		
		$(onConfirmAddBookmarkButton).addClass("bookmarked");
	}
	
	lvBookmark = null;
	onConfirmAddBookmarkButton = null;
}

function CreateHelpBar()
{
	var lvStation = GetTranslation(STATION);
	
	var _TRANSLATION =
	{
		HELP: ["說明", "Help"],
//		HELP_CONTENT: ["<ul style=\"padding-left:10px;margin-top:0;margin-bottom:0\"><li>乘列車前往<b>" + lvStation + "</b>站前，預先在建議落車位置 (卡-門)上車。到達<b>" + lvStation + "</b>站後，即可從該位置落車，以便轉車。</li><li>有關落車位置問題，請參閱<b>常見問題</b>。</li><li>可選擇「常用圖案」以新增落車位置到首頁的<b>常用</b>名單。</li><li>預計上車位置 - 到達上車月台時，預計上車的位置；可配合<b>落車指南</b>的落車位置使用</li></ul><img src=\"img/L.png\" /> (轉車時，使用升降機前往上車月台)"
//		, "<ul style=\"padding-left:10px;margin-top:0;margin-bottom:0\"><li>Before heading to <b>" + lvStation + " </b>Station, board the train at the suggested alighting position (car-door). Arriving at <b>" + lvStation + "</b> Station, alight at the position to speed up interchanging.</li><li>For questions about alighting position, please refer to <b>FAQ</b>.</li><li>Press '<b>Bookmark</b>' button to bookmark alighting position to the home page.</li><li>Estimated boarding position - The estimated boarding position after reaching the boarding platform; Can be used along with alighting position suggested by <b>Alighting Planner</b></li></ul><img src=\"img/L.png\" /> (During interchanging, use lift to reach the boarding platform)"]
		HELP_CONTENT: ['<ul style="padding-left: 10px; margin-top: 0; margin-bottom: 0"><li>預先從 (車卡號數 - 車門號數) 上車往<b>' + lvStation + '</b>站，到站轉車更快捷</li><li>月台閘門 / 地面設有<b>車卡號數</b>標貼</li><li>可按下<b>書籤</b>按鈕將落車位置加到首頁書籤</ul>', '<ul style="padding-left: 10px; margin-top: 0; margin-bottom: 0"><li>Board the train at (Car No - Door No) to <b>' + lvStation + '</b> Station for faster interchanging</li><li><b>Car No</b> are shown on platform doors / floor</li><li>Press <b>Bookmark</b> button to bookmark Alighting Position to Homepage</li></ul>']
	};
	
	var lvString = "<div id=\"help\" data-role=\"collapsible\" data-mini=\"true\"><h3>" + _TRANSLATION.HELP[LANG] + "</h3>" + _TRANSLATION.HELP_CONTENT[LANG] + "</div>";
	
	_TRANSLATION = null;
	
	$("#main").prepend(lvString);
	lvString = null;
	
	SetUpHelpBar($('#help'));
	
/*	$('#help').collapsible(
	{
		collapsedIcon: "info",
		expandedIcon: "info",
		collapsed: (Load("ExpandHelpBar") != "T"),
		expand: function(event, ui)
		{
			Save("ExpandHelpBar", "T");
		},
		collapse: function(event, ui)
		{
			Save("ExpandHelpBar", "F");
		}
	});
	
	$('#help').find('div.ui-collapsible-content').addClass('ui-mini');*/
}